submodule: Use cat instead of echo to avoid DOS line-endings
[git/dscho.git] / t / test-lib.sh
blobeadb24c86765eccb79f9925cd5cdb6a90aa32905
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # for git on windows so stdin will not be misdetected as attached to a
19 # terminal
20 exec < /dev/null
22 # if --tee was passed, write the output not only to the terminal, but
23 # additionally to the file test-results/$BASENAME.out, too.
24 case "$GIT_TEST_TEE_STARTED, $* " in
25 done,*)
26 # do not redirect again
28 *' --tee '*|*' --va'*)
29 mkdir -p test-results
30 BASE=test-results/$(basename "$0" .sh)
31 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
32 echo $? > $BASE.exit) | tee $BASE.out
33 test "$(cat $BASE.exit)" = 0
34 exit
36 esac
38 # Keep the original TERM for say_color
39 ORIGINAL_TERM=$TERM
41 # For repeatability, reset the environment to known value.
42 LANG=C
43 LC_ALL=C
44 PAGER=cat
45 TZ=UTC
46 TERM=dumb
47 export LANG LC_ALL PAGER TERM TZ
48 EDITOR=:
49 unset VISUAL
50 unset EMAIL
51 unset $(perl -e '
52 my @env = keys %ENV;
53 my $ok = join("|", qw(
54 TRACE
55 DEBUG
56 USE_LOOKUP
57 TEST
58 .*_TEST
59 PROVE
60 VALGRIND
61 ));
62 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
63 print join("\n", @vars);
65 GIT_AUTHOR_EMAIL=author@example.com
66 GIT_AUTHOR_NAME='A U Thor'
67 GIT_COMMITTER_EMAIL=committer@example.com
68 GIT_COMMITTER_NAME='C O Mitter'
69 GIT_MERGE_VERBOSITY=5
70 export GIT_MERGE_VERBOSITY
71 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
72 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
73 export EDITOR
75 # Protect ourselves from common misconfiguration to export
76 # CDPATH into the environment
77 unset CDPATH
79 unset GREP_OPTIONS
81 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
82 1|2|true)
83 echo "* warning: Some tests will not work if GIT_TRACE" \
84 "is set as to trace on STDERR ! *"
85 echo "* warning: Please set GIT_TRACE to something" \
86 "other than 1, 2 or true ! *"
88 esac
90 # Convenience
92 # A regexp to match 5 and 40 hexdigits
93 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
94 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
96 # Zero SHA-1
97 _z40=0000000000000000000000000000000000000000
99 # Line feed
100 LF='
103 # Each test should start with something like this, after copyright notices:
105 # test_description='Description of this test...
106 # This test checks if command xyzzy does the right thing...
108 # . ./test-lib.sh
109 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
110 TERM=$ORIGINAL_TERM &&
111 export TERM &&
112 [ -t 1 ] &&
113 tput bold >/dev/null 2>&1 &&
114 tput setaf 1 >/dev/null 2>&1 &&
115 tput sgr0 >/dev/null 2>&1
116 ) &&
117 color=t
119 while test "$#" -ne 0
121 case "$1" in
122 -d|--d|--de|--deb|--debu|--debug)
123 debug=t; shift ;;
124 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
125 immediate=t; shift ;;
126 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
127 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
128 -h|--h|--he|--hel|--help)
129 help=t; shift ;;
130 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
131 verbose=t; shift ;;
132 -q|--q|--qu|--qui|--quie|--quiet)
133 # Ignore --quiet under a TAP::Harness. Saying how many tests
134 # passed without the ok/not ok details is always an error.
135 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
136 --with-dashes)
137 with_dashes=t; shift ;;
138 --no-color)
139 color=; shift ;;
140 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
141 valgrind=t; verbose=t; shift ;;
142 --tee)
143 shift ;; # was handled already
144 --root=*)
145 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
146 shift ;;
148 echo "error: unknown test option '$1'" >&2; exit 1 ;;
149 esac
150 done
152 if test -n "$color"; then
153 say_color () {
155 TERM=$ORIGINAL_TERM
156 export TERM
157 case "$1" in
158 error) tput bold; tput setaf 1;; # bold red
159 skip) tput bold; tput setaf 2;; # bold green
160 pass) tput setaf 2;; # green
161 info) tput setaf 3;; # brown
162 *) test -n "$quiet" && return;;
163 esac
164 shift
165 printf "%s" "$*"
166 tput sgr0
167 echo
170 else
171 say_color() {
172 test -z "$1" && test -n "$quiet" && return
173 shift
174 echo "$*"
178 error () {
179 say_color error "error: $*"
180 GIT_EXIT_OK=t
181 exit 1
184 say () {
185 say_color info "$*"
188 test "${test_description}" != "" ||
189 error "Test script did not set test_description."
191 if test "$help" = "t"
192 then
193 echo "$test_description"
194 exit 0
197 exec 5>&1
198 if test "$verbose" = "t"
199 then
200 exec 4>&2 3>&1
201 else
202 exec 4>/dev/null 3>/dev/null
205 test_failure=0
206 test_count=0
207 test_fixed=0
208 test_broken=0
209 test_success=0
211 test_external_has_tap=0
213 die () {
214 code=$?
215 if test -n "$GIT_EXIT_OK"
216 then
217 exit $code
218 else
219 echo >&5 "FATAL: Unexpected exit with code $code"
220 exit 1
224 GIT_EXIT_OK=
225 trap 'die' EXIT
227 # The semantics of the editor variables are that of invoking
228 # sh -c "$EDITOR \"$@\"" files ...
230 # If our trash directory contains shell metacharacters, they will be
231 # interpreted if we just set $EDITOR directly, so do a little dance with
232 # environment variables to work around this.
234 # In particular, quoting isn't enough, as the path may contain the same quote
235 # that we're using.
236 test_set_editor () {
237 FAKE_EDITOR="$1"
238 export FAKE_EDITOR
239 EDITOR='"$FAKE_EDITOR"'
240 export EDITOR
243 test_decode_color () {
244 awk '
245 function name(n) {
246 if (n == 0) return "RESET";
247 if (n == 1) return "BOLD";
248 if (n == 30) return "BLACK";
249 if (n == 31) return "RED";
250 if (n == 32) return "GREEN";
251 if (n == 33) return "YELLOW";
252 if (n == 34) return "BLUE";
253 if (n == 35) return "MAGENTA";
254 if (n == 36) return "CYAN";
255 if (n == 37) return "WHITE";
256 if (n == 40) return "BLACK";
257 if (n == 41) return "BRED";
258 if (n == 42) return "BGREEN";
259 if (n == 43) return "BYELLOW";
260 if (n == 44) return "BBLUE";
261 if (n == 45) return "BMAGENTA";
262 if (n == 46) return "BCYAN";
263 if (n == 47) return "BWHITE";
266 while (match($0, /\033\[[0-9;]*m/) != 0) {
267 printf "%s<", substr($0, 1, RSTART-1);
268 codes = substr($0, RSTART+2, RLENGTH-3);
269 if (length(codes) == 0)
270 printf "%s", name(0)
271 else {
272 n = split(codes, ary, ";");
273 sep = "";
274 for (i = 1; i <= n; i++) {
275 printf "%s%s", sep, name(ary[i]);
276 sep = ";"
279 printf ">";
280 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
282 print
287 nul_to_q () {
288 perl -pe 'y/\000/Q/'
291 q_to_nul () {
292 perl -pe 'y/Q/\000/'
295 q_to_cr () {
296 tr Q '\015'
299 q_to_tab () {
300 tr Q '\011'
303 append_cr () {
304 sed -e 's/$/Q/' | tr Q '\015'
307 remove_cr () {
308 tr '\015' Q | sed -e 's/Q$//'
311 # In some bourne shell implementations, the "unset" builtin returns
312 # nonzero status when a variable to be unset was not set in the first
313 # place.
315 # Use sane_unset when that should not be considered an error.
317 sane_unset () {
318 unset "$@"
319 return 0
322 test_tick () {
323 if test -z "${test_tick+set}"
324 then
325 test_tick=1112911993
326 else
327 test_tick=$(($test_tick + 60))
329 GIT_COMMITTER_DATE="$test_tick -0700"
330 GIT_AUTHOR_DATE="$test_tick -0700"
331 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
334 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
336 # This will commit a file with the given contents and the given commit
337 # message. It will also add a tag with <message> as name.
339 # Both <file> and <contents> default to <message>.
341 test_commit () {
342 file=${2:-"$1.t"}
343 echo "${3-$1}" > "$file" &&
344 git add "$file" &&
345 test_tick &&
346 git commit -m "$1" &&
347 git tag "$1"
350 # Call test_merge with the arguments "<message> <commit>", where <commit>
351 # can be a tag pointing to the commit-to-merge.
353 test_merge () {
354 test_tick &&
355 git merge -m "$1" "$2" &&
356 git tag "$1"
359 # This function helps systems where core.filemode=false is set.
360 # Use it instead of plain 'chmod +x' to set or unset the executable bit
361 # of a file in the working directory and add it to the index.
363 test_chmod () {
364 chmod "$@" &&
365 git update-index --add "--chmod=$@"
368 # Unset a configuration variable, but don't fail if it doesn't exist.
369 test_unconfig () {
370 git config --unset-all "$@"
371 config_status=$?
372 case "$config_status" in
373 5) # ok, nothing to unset
374 config_status=0
376 esac
377 return $config_status
380 # Set git config, automatically unsetting it after the test is over.
381 test_config () {
382 test_when_finished "test_unconfig '$1'" &&
383 git config "$@"
386 # Use test_set_prereq to tell that a particular prerequisite is available.
387 # The prerequisite can later be checked for in two ways:
389 # - Explicitly using test_have_prereq.
391 # - Implicitly by specifying the prerequisite tag in the calls to
392 # test_expect_{success,failure,code}.
394 # The single parameter is the prerequisite tag (a simple word, in all
395 # capital letters by convention).
397 test_set_prereq () {
398 satisfied="$satisfied$1 "
400 satisfied=" "
402 test_have_prereq () {
403 # prerequisites can be concatenated with ','
404 save_IFS=$IFS
405 IFS=,
406 set -- $*
407 IFS=$save_IFS
409 total_prereq=0
410 ok_prereq=0
411 missing_prereq=
413 for prerequisite
415 total_prereq=$(($total_prereq + 1))
416 case $satisfied in
417 *" $prerequisite "*)
418 ok_prereq=$(($ok_prereq + 1))
421 # Keep a list of missing prerequisites
422 if test -z "$missing_prereq"
423 then
424 missing_prereq=$prerequisite
425 else
426 missing_prereq="$prerequisite,$missing_prereq"
428 esac
429 done
431 test $total_prereq = $ok_prereq
434 test_declared_prereq () {
435 case ",$test_prereq," in
436 *,$1,*)
437 return 0
439 esac
440 return 1
443 # You are not expected to call test_ok_ and test_failure_ directly, use
444 # the text_expect_* functions instead.
446 test_ok_ () {
447 test_success=$(($test_success + 1))
448 say_color "" "ok $test_count - $@"
451 test_failure_ () {
452 test_failure=$(($test_failure + 1))
453 say_color error "not ok - $test_count $1"
454 shift
455 echo "$@" | sed -e 's/^/# /'
456 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
459 test_known_broken_ok_ () {
460 test_fixed=$(($test_fixed+1))
461 say_color "" "ok $test_count - $@ # TODO known breakage"
464 test_known_broken_failure_ () {
465 test_broken=$(($test_broken+1))
466 say_color skip "not ok $test_count - $@ # TODO known breakage"
469 test_debug () {
470 test "$debug" = "" || eval "$1"
473 test_eval_ () {
474 # This is a separate function because some tests use
475 # "return" to end a test_expect_success block early.
476 eval >&3 2>&4 "$*"
479 test_run_ () {
480 test_cleanup=:
481 expecting_failure=$2
482 test_eval_ "$1"
483 eval_ret=$?
485 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
486 then
487 test_eval_ "$test_cleanup"
489 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
490 echo ""
492 return "$eval_ret"
495 test_skip () {
496 test_count=$(($test_count+1))
497 to_skip=
498 for skp in $GIT_SKIP_TESTS
500 case $this_test.$test_count in
501 $skp)
502 to_skip=t
503 break
504 esac
505 done
506 if test -z "$to_skip" && test -n "$test_prereq" &&
507 ! test_have_prereq "$test_prereq"
508 then
509 to_skip=t
511 case "$to_skip" in
513 of_prereq=
514 if test "$missing_prereq" != "$test_prereq"
515 then
516 of_prereq=" of $test_prereq"
519 say_color skip >&3 "skipping test: $@"
520 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
521 : true
524 false
526 esac
529 test_expect_failure () {
530 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
531 test "$#" = 2 ||
532 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
533 export test_prereq
534 if ! test_skip "$@"
535 then
536 say >&3 "checking known breakage: $2"
537 if test_run_ "$2" expecting_failure
538 then
539 test_known_broken_ok_ "$1"
540 else
541 test_known_broken_failure_ "$1"
544 echo >&3 ""
547 test_expect_success () {
548 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
549 test "$#" = 2 ||
550 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
551 export test_prereq
552 if ! test_skip "$@"
553 then
554 say >&3 "expecting success: $2"
555 if test_run_ "$2"
556 then
557 test_ok_ "$1"
558 else
559 test_failure_ "$@"
562 echo >&3 ""
565 # test_external runs external test scripts that provide continuous
566 # test output about their progress, and succeeds/fails on
567 # zero/non-zero exit code. It outputs the test output on stdout even
568 # in non-verbose mode, and announces the external script with "# run
569 # <n>: ..." before running it. When providing relative paths, keep in
570 # mind that all scripts run in "trash directory".
571 # Usage: test_external description command arguments...
572 # Example: test_external 'Perl API' perl ../path/to/test.pl
573 test_external () {
574 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
575 test "$#" = 3 ||
576 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
577 descr="$1"
578 shift
579 export test_prereq
580 if ! test_skip "$descr" "$@"
581 then
582 # Announce the script to reduce confusion about the
583 # test output that follows.
584 say_color "" "# run $test_count: $descr ($*)"
585 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
586 # to be able to use them in script
587 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
588 # Run command; redirect its stderr to &4 as in
589 # test_run_, but keep its stdout on our stdout even in
590 # non-verbose mode.
591 "$@" 2>&4
592 if [ "$?" = 0 ]
593 then
594 if test $test_external_has_tap -eq 0; then
595 test_ok_ "$descr"
596 else
597 say_color "" "# test_external test $descr was ok"
598 test_success=$(($test_success + 1))
600 else
601 if test $test_external_has_tap -eq 0; then
602 test_failure_ "$descr" "$@"
603 else
604 say_color error "# test_external test $descr failed: $@"
605 test_failure=$(($test_failure + 1))
611 # Like test_external, but in addition tests that the command generated
612 # no output on stderr.
613 test_external_without_stderr () {
614 # The temporary file has no (and must have no) security
615 # implications.
616 tmp=${TMPDIR:-/tmp}
617 stderr="$tmp/git-external-stderr.$$.tmp"
618 test_external "$@" 4> "$stderr"
619 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
620 descr="no stderr: $1"
621 shift
622 say >&3 "# expecting no stderr from previous command"
623 if [ ! -s "$stderr" ]; then
624 rm "$stderr"
626 if test $test_external_has_tap -eq 0; then
627 test_ok_ "$descr"
628 else
629 say_color "" "# test_external_without_stderr test $descr was ok"
630 test_success=$(($test_success + 1))
632 else
633 if [ "$verbose" = t ]; then
634 output=`echo; echo "# Stderr is:"; cat "$stderr"`
635 else
636 output=
638 # rm first in case test_failure exits.
639 rm "$stderr"
640 if test $test_external_has_tap -eq 0; then
641 test_failure_ "$descr" "$@" "$output"
642 else
643 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
644 test_failure=$(($test_failure + 1))
649 # debugging-friendly alternatives to "test [-f|-d|-e]"
650 # The commands test the existence or non-existence of $1. $2 can be
651 # given to provide a more precise diagnosis.
652 test_path_is_file () {
653 if ! [ -f "$1" ]
654 then
655 echo "File $1 doesn't exist. $*"
656 false
660 test_path_is_dir () {
661 if ! [ -d "$1" ]
662 then
663 echo "Directory $1 doesn't exist. $*"
664 false
668 test_path_is_missing () {
669 if [ -e "$1" ]
670 then
671 echo "Path exists:"
672 ls -ld "$1"
673 if [ $# -ge 1 ]; then
674 echo "$*"
676 false
680 # test_line_count checks that a file has the number of lines it
681 # ought to. For example:
683 # test_expect_success 'produce exactly one line of output' '
684 # do something >output &&
685 # test_line_count = 1 output
688 # is like "test $(wc -l <output) = 1" except that it passes the
689 # output through when the number of lines is wrong.
691 test_line_count () {
692 if test $# != 3
693 then
694 error "bug in the test script: not 3 parameters to test_line_count"
695 elif ! test $(wc -l <"$3") "$1" "$2"
696 then
697 echo "test_line_count: line count for $3 !$1 $2"
698 cat "$3"
699 return 1
703 # This is not among top-level (test_expect_success | test_expect_failure)
704 # but is a prefix that can be used in the test script, like:
706 # test_expect_success 'complain and die' '
707 # do something &&
708 # do something else &&
709 # test_must_fail git checkout ../outerspace
712 # Writing this as "! git checkout ../outerspace" is wrong, because
713 # the failure could be due to a segv. We want a controlled failure.
715 test_must_fail () {
716 "$@"
717 exit_code=$?
718 if test $exit_code = 0; then
719 echo >&2 "test_must_fail: command succeeded: $*"
720 return 1
721 elif test $exit_code -gt 129 -a $exit_code -le 192; then
722 echo >&2 "test_must_fail: died by signal: $*"
723 return 1
724 elif test $exit_code = 127; then
725 echo >&2 "test_must_fail: command not found: $*"
726 return 1
728 return 0
731 # Similar to test_must_fail, but tolerates success, too. This is
732 # meant to be used in contexts like:
734 # test_expect_success 'some command works without configuration' '
735 # test_might_fail git config --unset all.configuration &&
736 # do something
739 # Writing "git config --unset all.configuration || :" would be wrong,
740 # because we want to notice if it fails due to segv.
742 test_might_fail () {
743 "$@"
744 exit_code=$?
745 if test $exit_code -gt 129 -a $exit_code -le 192; then
746 echo >&2 "test_might_fail: died by signal: $*"
747 return 1
748 elif test $exit_code = 127; then
749 echo >&2 "test_might_fail: command not found: $*"
750 return 1
752 return 0
755 # Similar to test_must_fail and test_might_fail, but check that a
756 # given command exited with a given exit code. Meant to be used as:
758 # test_expect_success 'Merge with d/f conflicts' '
759 # test_expect_code 1 git merge "merge msg" B master
762 test_expect_code () {
763 want_code=$1
764 shift
765 "$@"
766 exit_code=$?
767 if test $exit_code = $want_code
768 then
769 return 0
772 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
773 return 1
776 # test_cmp is a helper function to compare actual and expected output.
777 # You can use it like:
779 # test_expect_success 'foo works' '
780 # echo expected >expected &&
781 # foo >actual &&
782 # test_cmp expected actual
785 # This could be written as either "cmp" or "diff -u", but:
786 # - cmp's output is not nearly as easy to read as diff -u
787 # - not all diff versions understand "-u"
789 test_cmp() {
790 $GIT_TEST_CMP "$@"
793 # This function can be used to schedule some commands to be run
794 # unconditionally at the end of the test to restore sanity:
796 # test_expect_success 'test core.capslock' '
797 # git config core.capslock true &&
798 # test_when_finished "git config --unset core.capslock" &&
799 # hello world
802 # That would be roughly equivalent to
804 # test_expect_success 'test core.capslock' '
805 # git config core.capslock true &&
806 # hello world
807 # git config --unset core.capslock
810 # except that the greeting and config --unset must both succeed for
811 # the test to pass.
813 # Note that under --immediate mode, no clean-up is done to help diagnose
814 # what went wrong.
816 test_when_finished () {
817 test_cleanup="{ $*
818 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
821 # Most tests can use the created repository, but some may need to create more.
822 # Usage: test_create_repo <directory>
823 test_create_repo () {
824 test "$#" = 1 ||
825 error "bug in the test script: not 1 parameter to test-create-repo"
826 repo="$1"
827 mkdir -p "$repo"
829 cd "$repo" || error "Cannot setup test environment"
830 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
831 error "cannot run git init -- have you built things yet?"
832 mv .git/hooks .git/hooks-disabled
833 ) || exit
836 test_done () {
837 GIT_EXIT_OK=t
839 if test -z "$HARNESS_ACTIVE"; then
840 test_results_dir="$TEST_DIRECTORY/test-results"
841 mkdir -p "$test_results_dir"
842 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
844 cat >>"$test_results_path" <<-EOF
845 total $test_count
846 success $test_success
847 fixed $test_fixed
848 broken $test_broken
849 failed $test_failure
854 if test "$test_fixed" != 0
855 then
856 say_color pass "# fixed $test_fixed known breakage(s)"
858 if test "$test_broken" != 0
859 then
860 say_color error "# still have $test_broken known breakage(s)"
861 msg="remaining $(($test_count-$test_broken)) test(s)"
862 else
863 msg="$test_count test(s)"
865 case "$test_failure" in
867 # Maybe print SKIP message
868 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
870 if test $test_external_has_tap -eq 0; then
871 say_color pass "# passed all $msg"
872 say "1..$test_count$skip_all"
875 test -d "$remove_trash" &&
876 cd "$(dirname "$remove_trash")" &&
877 rm -rf "$(basename "$remove_trash")"
879 exit 0 ;;
882 if test $test_external_has_tap -eq 0; then
883 say_color error "# failed $test_failure among $msg"
884 say "1..$test_count"
887 exit 1 ;;
889 esac
892 # Test the binaries we have just built. The tests are kept in
893 # t/ subdirectory and are run in 'trash directory' subdirectory.
894 if test -z "$TEST_DIRECTORY"
895 then
896 # We allow tests to override this, in case they want to run tests
897 # outside of t/, e.g. for running tests on the test library
898 # itself.
899 TEST_DIRECTORY=$(pwd)
901 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
903 if test -n "$valgrind"
904 then
905 make_symlink () {
906 test -h "$2" &&
907 test "$1" = "$(readlink "$2")" || {
908 # be super paranoid
909 if mkdir "$2".lock
910 then
911 rm -f "$2" &&
912 ln -s "$1" "$2" &&
913 rm -r "$2".lock
914 else
915 while test -d "$2".lock
917 say "Waiting for lock on $2."
918 sleep 1
919 done
924 make_valgrind_symlink () {
925 # handle only executables, unless they are shell libraries that
926 # need to be in the exec-path. We will just use "#!" as a
927 # guess for a shell-script, since we have no idea what the user
928 # may have configured as the shell path.
929 test -x "$1" ||
930 test "#!" = "$(head -c 2 <"$1")" ||
931 return;
933 base=$(basename "$1")
934 symlink_target=$GIT_BUILD_DIR/$base
935 # do not override scripts
936 if test -x "$symlink_target" &&
937 test ! -d "$symlink_target" &&
938 test "#!" != "$(head -c 2 < "$symlink_target")"
939 then
940 symlink_target=../valgrind.sh
942 case "$base" in
943 *.sh|*.perl)
944 symlink_target=../unprocessed-script
945 esac
946 # create the link, or replace it if it is out of date
947 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
950 # override all git executables in TEST_DIRECTORY/..
951 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
952 mkdir -p "$GIT_VALGRIND"/bin
953 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
955 make_valgrind_symlink $file
956 done
957 # special-case the mergetools loadables
958 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
959 OLDIFS=$IFS
960 IFS=:
961 for path in $PATH
963 ls "$path"/git-* 2> /dev/null |
964 while read file
966 make_valgrind_symlink "$file"
967 done
968 done
969 IFS=$OLDIFS
970 PATH=$GIT_VALGRIND/bin:$PATH
971 GIT_EXEC_PATH=$GIT_VALGRIND/bin
972 export GIT_VALGRIND
973 elif test -n "$GIT_TEST_INSTALLED" ; then
974 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
975 error "Cannot run git from $GIT_TEST_INSTALLED."
976 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
977 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
978 else # normal case, use ../bin-wrappers only unless $with_dashes:
979 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
980 if ! test -x "$git_bin_dir/git" ; then
981 if test -z "$with_dashes" ; then
982 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
984 with_dashes=t
986 PATH="$git_bin_dir:$PATH"
987 GIT_EXEC_PATH=$GIT_BUILD_DIR
988 if test -n "$with_dashes" ; then
989 PATH="$GIT_BUILD_DIR:$PATH"
992 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
993 unset GIT_CONFIG
994 GIT_CONFIG_NOSYSTEM=1
995 GIT_ATTR_NOSYSTEM=1
996 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
998 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1000 if test -z "$GIT_TEST_CMP"
1001 then
1002 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1003 then
1004 GIT_TEST_CMP="$DIFF -c"
1005 else
1006 GIT_TEST_CMP="$DIFF -u"
1010 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1011 export GITPERLLIB
1012 test -d "$GIT_BUILD_DIR"/templates/blt || {
1013 error "You haven't built things yet, have you?"
1016 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1017 then
1018 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1019 export GITPYTHONLIB
1020 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1021 error "You haven't built git_remote_helpers yet, have you?"
1025 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1026 echo >&2 'You need to build test-chmtime:'
1027 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1028 exit 1
1031 # Test repository
1032 test="trash directory.$(basename "$0" .sh)"
1033 test -n "$root" && test="$root/$test"
1034 case "$test" in
1035 /*) TRASH_DIRECTORY="$test" ;;
1036 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1037 esac
1038 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1039 rm -fr "$test" || {
1040 GIT_EXIT_OK=t
1041 echo >&5 "FATAL: Cannot prepare test area"
1042 exit 1
1045 HOME="$TRASH_DIRECTORY"
1046 export HOME
1048 test_create_repo "$test"
1049 # Use -P to resolve symlinks in our working directory so that the cwd
1050 # in subprocesses like git equals our $PWD (for pathname comparisons).
1051 cd -P "$test" || exit 1
1053 this_test=${0##*/}
1054 this_test=${this_test%%-*}
1055 for skp in $GIT_SKIP_TESTS
1057 case "$this_test" in
1058 $skp)
1059 say_color skip >&3 "skipping test $this_test altogether"
1060 skip_all="skip all tests in $this_test"
1061 test_done
1062 esac
1063 done
1065 # Provide an implementation of the 'yes' utility
1066 yes () {
1067 if test $# = 0
1068 then
1070 else
1071 y="$*"
1074 while echo "$y"
1077 done
1080 # Fix some commands on Windows
1081 case $(uname -s) in
1082 *MINGW*)
1083 # Windows has its own (incompatible) sort and find
1084 sort () {
1085 /usr/bin/sort "$@"
1087 find () {
1088 /usr/bin/find "$@"
1090 sum () {
1091 md5sum "$@"
1093 # git sees Windows-style pwd
1094 pwd () {
1095 builtin pwd -W
1097 # no POSIX permissions
1098 # backslashes in pathspec are converted to '/'
1099 # exec does not inherit the PID
1100 test_set_prereq MINGW
1101 test_set_prereq SED_STRIPS_CR
1103 *CYGWIN*)
1104 test_set_prereq POSIXPERM
1105 test_set_prereq EXECKEEPSPID
1106 test_set_prereq NOT_MINGW
1107 test_set_prereq SED_STRIPS_CR
1110 test_set_prereq POSIXPERM
1111 test_set_prereq BSLASHPSPEC
1112 test_set_prereq EXECKEEPSPID
1113 test_set_prereq NOT_MINGW
1115 esac
1117 test -z "$NO_PERL" && test_set_prereq PERL
1118 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1119 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1121 # Can we rely on git's output in the C locale?
1122 if test -n "$GETTEXT_POISON"
1123 then
1124 GIT_GETTEXT_POISON=YesPlease
1125 export GIT_GETTEXT_POISON
1126 else
1127 test_set_prereq C_LOCALE_OUTPUT
1130 # Use this instead of test_cmp to compare files that contain expected and
1131 # actual output from git commands that can be translated. When running
1132 # under GETTEXT_POISON this pretends that the command produced expected
1133 # results.
1134 test_i18ncmp () {
1135 test -n "$GETTEXT_POISON" || test_cmp "$@"
1138 # Use this instead of "grep expected-string actual" to see if the
1139 # output from a git command that can be translated either contains an
1140 # expected string, or does not contain an unwanted one. When running
1141 # under GETTEXT_POISON this pretends that the command produced expected
1142 # results.
1143 test_i18ngrep () {
1144 if test -n "$GETTEXT_POISON"
1145 then
1146 : # pretend success
1147 elif test "x!" = "x$1"
1148 then
1149 shift
1150 ! grep "$@"
1151 else
1152 grep "$@"
1156 # test whether the filesystem supports symbolic links
1157 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1158 rm -f y
1160 # When the tests are run as root, permission tests will report that
1161 # things are writable when they shouldn't be.
1162 test -w / || test_set_prereq SANITY